<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>documentation/info_segments/encode_clock_value_.info</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.textRainbow_lv1_p0 { color: #ffffe0; }
.textRainbow_lv0_o0 { color: #add8e6; }
.textRainbow_lv0_p0 { color: #add8e6; }
.LineNr { color: #585858; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr">  1 </span>03/08/85  encode_clock_value_
<span id="L2" class="LineNr">  2 </span>
<span id="L3" class="LineNr">  3 </span>
<span id="L4" class="LineNr">  4 </span>NOTE:
<span id="L5" class="LineNr">  5 </span>     encode_clock_value_ is replaced by date_time_$to_clock;
<span id="L6" class="LineNr">  6 </span>     encode_clock_value_ is supported for compatibility only.
<span id="L7" class="LineNr">  7 </span>
<span id="L8" class="LineNr">  8 </span>
<span id="L9" class="LineNr">  9 </span>Entry points in encode_clock_value_:
<span id="L10" class="LineNr"> 10 </span>   <span class="textRainbow_lv0_p0">(</span>List is generated by the help command<span class="textRainbow_lv0_p0">)</span>
<span id="L11" class="LineNr"> 11 </span>
<span id="L12" class="LineNr"> 12 </span>
<span id="L13" class="LineNr"> 13 </span>:Entry:  encode_clock_value_:  03/08/85  encode_clock_value_
<span id="L14" class="LineNr"> 14 </span>
<span id="L15" class="LineNr"> 15 </span>
<span id="L16" class="LineNr"> 16 </span>Function:
<span id="L17" class="LineNr"> 17 </span>The encode_clock_value_ subroutine takes a given month, day of the
<span id="L18" class="LineNr"> 18 </span>month, year, hour of the day, minute, second, microsecond, and time
<span id="L19" class="LineNr"> 19 </span>zone and returns a system clock reading.  When given a day of the week,
<span id="L20" class="LineNr"> 20 </span>it performs an optional check on the clock reading to ensure that it
<span id="L21" class="LineNr"> 21 </span>falls on the given day.
<span id="L22" class="LineNr"> 22 </span>
<span id="L23" class="LineNr"> 23 </span>A system clock reading is encoded as the number of microseconds from
<span id="L24" class="LineNr"> 24 </span>January 1, 1901 0000.0, Greenwich Mean Time <span class="textRainbow_lv0_p0">(</span>GMT<span class="textRainbow_lv0_p0">)</span> to the given date,
<span id="L25" class="LineNr"> 25 </span>time, and time zone.
<span id="L26" class="LineNr"> 26 </span>
<span id="L27" class="LineNr"> 27 </span>
<span id="L28" class="LineNr"> 28 </span>Syntax:
<span id="L29" class="LineNr"> 29 </span>declare encode_clock_value_ entry <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv0_o0">,</span>
<span id="L30" class="LineNr"> 30 </span>     fixed bin<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>71<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv0_o0">,</span>
<span id="L31" class="LineNr"> 31 </span>     char<span class="textRainbow_lv1_p0">(</span>3<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>71<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L32" class="LineNr"> 32 </span>call encode_clock_value_ <span class="textRainbow_lv0_p0">(</span>month<span class="textRainbow_lv0_o0">,</span> dom<span class="textRainbow_lv0_o0">,</span> year<span class="textRainbow_lv0_o0">,</span> hour<span class="textRainbow_lv0_o0">,</span> minute<span class="textRainbow_lv0_o0">,</span> second<span class="textRainbow_lv0_o0">,</span>
<span id="L33" class="LineNr"> 33 </span>     microsecond<span class="textRainbow_lv0_o0">,</span> dow<span class="textRainbow_lv0_o0">,</span> zone<span class="textRainbow_lv0_o0">,</span> clock<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L34" class="LineNr"> 34 </span>
<span id="L35" class="LineNr"> 35 </span>
<span id="L36" class="LineNr"> 36 </span>Arguments:
<span id="L37" class="LineNr"> 37 </span>month
<span id="L38" class="LineNr"> 38 </span>   is the month <span class="textRainbow_lv0_p0">(</span>January = 1<span class="textRainbow_lv0_o0">,</span> ...<span class="textRainbow_lv0_o0">,</span> December = 12<span class="textRainbow_lv0_p0">)</span>.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L39" class="LineNr"> 39 </span>dom
<span id="L40" class="LineNr"> 40 </span>   is the day of the month, i.e., 1 to 31.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L41" class="LineNr"> 41 </span>year
<span id="L42" class="LineNr"> 42 </span>   is the year, e.g., 1982.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L43" class="LineNr"> 43 </span>
<span id="L44" class="LineNr"> 44 </span>
<span id="L45" class="LineNr"> 45 </span>hour
<span id="L46" class="LineNr"> 46 </span>   is the hour of the day <span class="textRainbow_lv0_p0">(</span>midnight = 0<span class="textRainbow_lv0_o0">,</span> ...<span class="textRainbow_lv0_o0">,</span> 11 PM = 23<span class="textRainbow_lv0_p0">)</span>.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L47" class="LineNr"> 47 </span>minute
<span id="L48" class="LineNr"> 48 </span>   is the minute of the hour, i.e., 0 to 59.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L49" class="LineNr"> 49 </span>second
<span id="L50" class="LineNr"> 50 </span>   is the second of the minute, i.e., 0 to 59.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L51" class="LineNr"> 51 </span>microsecond
<span id="L52" class="LineNr"> 52 </span>   is the number of microseconds that are added to the clock reading
<span id="L53" class="LineNr"> 53 </span>   encoded from the given month, dom, year, hour, minute, and second.
<span id="L54" class="LineNr"> 54 </span>   <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L55" class="LineNr"> 55 </span>
<span id="L56" class="LineNr"> 56 </span>
<span id="L57" class="LineNr"> 57 </span>dow
<span id="L58" class="LineNr"> 58 </span>   is the day of the week <span class="textRainbow_lv0_p0">(</span>0 = no day of week checking<span class="textRainbow_lv0_o0">,</span> 1 = Monday<span class="textRainbow_lv0_o0">,</span>
<span id="L59" class="LineNr"> 59 </span>   ...<span class="textRainbow_lv0_o0">,</span> 7 = Sunday<span class="textRainbow_lv0_p0">)</span>.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L60" class="LineNr"> 60 </span>zone
<span id="L61" class="LineNr"> 61 </span>   is a three-character abbreviation of the time zone in which the
<span id="L62" class="LineNr"> 62 </span>   given day of the month and hour are expressed.  <span class="textRainbow_lv0_p0">(</span>Input or Output<span class="textRainbow_lv0_p0">)</span>
<span id="L63" class="LineNr"> 63 </span>   Input
<span id="L64" class="LineNr"> 64 </span>      is one of the zone abbreviations given in the table of time zones
<span id="L65" class="LineNr"> 65 </span>      <span class="textRainbow_lv0_p0">(</span>see the convert_date_to_binary_ subroutine<span class="textRainbow_lv0_p0">)</span>, or is a null
<span id="L66" class="LineNr"> 66 </span>      character string.  A zone abbreviation may be given in uppercase
<span id="L67" class="LineNr"> 67 </span>      or lowercase.  If a null string is given, the current time zone
<span id="L68" class="LineNr"> 68 </span>      used by the process is assumed.
<span id="L69" class="LineNr"> 69 </span>   Output
<span id="L70" class="LineNr"> 70 </span>      is a three-character lowercase abbreviation of the current time
<span id="L71" class="LineNr"> 71 </span>      zone used by the process if a null character string was given as
<span id="L72" class="LineNr"> 72 </span>      input.
<span id="L73" class="LineNr"> 73 </span>
<span id="L74" class="LineNr"> 74 </span>
<span id="L75" class="LineNr"> 75 </span>clock
<span id="L76" class="LineNr"> 76 </span>   is the encoded system clock reading.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L77" class="LineNr"> 77 </span>code
<span id="L78" class="LineNr"> 78 </span>   is a system status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L79" class="LineNr"> 79 </span>
<span id="L80" class="LineNr"> 80 </span>
<span id="L81" class="LineNr"> 81 </span>:Entry:  offsets:  03/08/85 encode_clock_value_$offsets
<span id="L82" class="LineNr"> 82 </span>
<span id="L83" class="LineNr"> 83 </span>
<span id="L84" class="LineNr"> 84 </span>NOTE:
<span id="L85" class="LineNr"> 85 </span>     encode_clock_value_$offsets is replaced by
<span id="L86" class="LineNr"> 86 </span>     date_time_$offset_to_clock; encode_clock_value_$offsets is
<span id="L87" class="LineNr"> 87 </span>     supported for compatibility only.
<span id="L88" class="LineNr"> 88 </span>
<span id="L89" class="LineNr"> 89 </span>
<span id="L90" class="LineNr"> 90 </span>Function:
<span id="L91" class="LineNr"> 91 </span>This entry point takes a system clock reading, a day of the week, and
<span id="L92" class="LineNr"> 92 </span>year, month, day, hour, minute, second, and microsecond, offset values.
<span id="L93" class="LineNr"> 93 </span>The offset values may be positive, negative, or zero.  It returns a
<span id="L94" class="LineNr"> 94 </span>clock reading that has been adjusted to fall on the given day of the
<span id="L95" class="LineNr"> 95 </span>week, and which is then offset by the given number of years, months,
<span id="L96" class="LineNr"> 96 </span>days, hours, minutes, seconds, and microseconds.
<span id="L97" class="LineNr"> 97 </span>
<span id="L98" class="LineNr"> 98 </span>
<span id="L99" class="LineNr"> 99 </span>Syntax:
<span id="L100" class="LineNr">100 </span>declare encode_clock_value_$offsets entry <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv1_p0">(</span>71<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv0_o0">,</span>
<span id="L101" class="LineNr">101 </span>     fixed bin<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv0_o0">,</span>
<span id="L102" class="LineNr">102 </span>     fixed bin<span class="textRainbow_lv1_p0">(</span>71<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv0_o0">,</span> char<span class="textRainbow_lv1_p0">(</span>3<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>71<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L103" class="LineNr">103 </span>call encode_clock_value_$offsets <span class="textRainbow_lv0_p0">(</span>clock_in<span class="textRainbow_lv0_o0">,</span> month_off<span class="textRainbow_lv0_o0">,</span> day_off<span class="textRainbow_lv0_o0">,</span>
<span id="L104" class="LineNr">104 </span>     year_off<span class="textRainbow_lv0_o0">,</span> hour_off<span class="textRainbow_lv0_o0">,</span> minute_off<span class="textRainbow_lv0_o0">,</span> second_off<span class="textRainbow_lv0_o0">,</span> microsec_off<span class="textRainbow_lv0_o0">,</span>
<span id="L105" class="LineNr">105 </span>     dow_offset<span class="textRainbow_lv0_o0">,</span> zone<span class="textRainbow_lv0_o0">,</span> clock_out<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L106" class="LineNr">106 </span>
<span id="L107" class="LineNr">107 </span>
<span id="L108" class="LineNr">108 </span>Arguments:
<span id="L109" class="LineNr">109 </span>clock_in
<span id="L110" class="LineNr">110 </span>   is a system clock reading.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L111" class="LineNr">111 </span>month_off
<span id="L112" class="LineNr">112 </span>   is an offset, in months.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L113" class="LineNr">113 </span>day_off
<span id="L114" class="LineNr">114 </span>   is an offset, in days.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L115" class="LineNr">115 </span>year_off
<span id="L116" class="LineNr">116 </span>   is an offset, in years.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L117" class="LineNr">117 </span>
<span id="L118" class="LineNr">118 </span>
<span id="L119" class="LineNr">119 </span>hour_off
<span id="L120" class="LineNr">120 </span>   is an offset, in hours.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L121" class="LineNr">121 </span>minute_off
<span id="L122" class="LineNr">122 </span>   is an offset, in minutes.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L123" class="LineNr">123 </span>second_off
<span id="L124" class="LineNr">124 </span>   is an offset, in seconds.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L125" class="LineNr">125 </span>microsec_off
<span id="L126" class="LineNr">126 </span>   is an offset, in microseconds.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L127" class="LineNr">127 </span>dow_off
<span id="L128" class="LineNr">128 </span>   is a day of the week offset <span class="textRainbow_lv0_p0">(</span>0 = no day of week offset<span class="textRainbow_lv0_o0">,</span>
<span id="L129" class="LineNr">129 </span>   1 = offset to next Monday<span class="textRainbow_lv0_o0">,</span> ...<span class="textRainbow_lv0_o0">,</span> 7 = offset to next Sunday<span class="textRainbow_lv0_p0">)</span>.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L130" class="LineNr">130 </span>
<span id="L131" class="LineNr">131 </span>
<span id="L132" class="LineNr">132 </span>zone
<span id="L133" class="LineNr">133 </span>   is a three-character abbreviation of the time zone in which the
<span id="L134" class="LineNr">134 </span>   input clock reading is to be interpreted.  <span class="textRainbow_lv0_p0">(</span>Input or Output<span class="textRainbow_lv0_p0">)</span> The
<span id="L135" class="LineNr">135 </span>   choice of zone may alter which day of the week the input clock
<span id="L136" class="LineNr">136 </span>   reading falls on, and may therefore affect any day of the week
<span id="L137" class="LineNr">137 </span>   adjustment.
<span id="L138" class="LineNr">138 </span>   Input
<span id="L139" class="LineNr">139 </span>      is one of the zone abbreviations given in the table of time zones
<span id="L140" class="LineNr">140 </span>      <span class="textRainbow_lv0_p0">(</span>see the convert_date_to_binary_ subroutine<span class="textRainbow_lv0_p0">)</span>, or is a null
<span id="L141" class="LineNr">141 </span>      character string.  A zone abbreviation may be given in uppercase
<span id="L142" class="LineNr">142 </span>      or lowercase.  If a null string is given, the current time zone
<span id="L143" class="LineNr">143 </span>      used by the process is assumed.
<span id="L144" class="LineNr">144 </span>   Output
<span id="L145" class="LineNr">145 </span>      is a three-character lowercase abbreviation of the current time
<span id="L146" class="LineNr">146 </span>      zone used by the process if a null character string was given as
<span id="L147" class="LineNr">147 </span>      input.
<span id="L148" class="LineNr">148 </span>
<span id="L149" class="LineNr">149 </span>
<span id="L150" class="LineNr">150 </span>clock_out
<span id="L151" class="LineNr">151 </span>   is the adjusted clock reading.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L152" class="LineNr">152 </span>code
<span id="L153" class="LineNr">153 </span>   is a system status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L154" class="LineNr">154 </span>
<span id="L155" class="LineNr">155 </span>
<span id="L156" class="LineNr">156 </span>Notes:  The order in which offsets are applied to the input clock
<span id="L157" class="LineNr">157 </span>reading can affect the adjusted clock reading.  The
<span id="L158" class="LineNr">158 </span>encode_clock_value_$offsets entry point uses the order required by the
<span id="L159" class="LineNr">159 </span>convert_date_to_binary_ subroutine in all cases.  The offsets are
<span id="L160" class="LineNr">160 </span>applied in the following order:
<span id="L161" class="LineNr">161 </span>
<span id="L162" class="LineNr">162 </span>1.   Decode the input clock reading into absolute date and time values
<span id="L163" class="LineNr">163 </span>     specified in terms of the input time zone.  The time zone can
<span id="L164" class="LineNr">164 </span>     alter the day of the week the input clock reading falls on, and
<span id="L165" class="LineNr">165 </span>     can therefore change the effect of the day of the week offset.
<span id="L166" class="LineNr">166 </span>
<span id="L167" class="LineNr">167 </span>2.   Apply any day of the week offset by adding days to the absolute
<span id="L168" class="LineNr">168 </span>     date values from step 1 until the date falls on the given day of
<span id="L169" class="LineNr">169 </span>     the week.
<span id="L170" class="LineNr">170 </span>
<span id="L171" class="LineNr">171 </span>3.   Apply any year offset to the absolute date values from step 2.
<span id="L172" class="LineNr">172 </span>
<span id="L173" class="LineNr">173 </span>4.   Apply any month offset to the absolute date values from step 3.
<span id="L174" class="LineNr">174 </span>     If applying the month offset results in an invalid date
<span id="L175" class="LineNr">175 </span>     <span class="textRainbow_lv0_p0">(</span>e.g.<span class="textRainbow_lv0_o0">,</span> 1/31/77 +3 months yields 4/31/77<span class="textRainbow_lv0_p0">)</span>, then adjust the day of
<span id="L176" class="LineNr">176 </span>     the month to be the last day of the new month, taking leap years
<span id="L177" class="LineNr">177 </span>     into account.
<span id="L178" class="LineNr">178 </span>
<span id="L179" class="LineNr">179 </span>5.   Apply the day offset to the absolute date values from step 4.
<span id="L180" class="LineNr">180 </span>
<span id="L181" class="LineNr">181 </span>6.   Apply the hour, minute, second, and microsecond offsets to the
<span id="L182" class="LineNr">182 </span>     absolute time values from step 1.
<span id="L183" class="LineNr">183 </span>
<span id="L184" class="LineNr">184 </span>7.   Encode the absolute date values from step 5 and absolute time
<span id="L185" class="LineNr">185 </span>     values from step 6 to form the adjusted clock reading.
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
